"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.checkClass = exports.classIntersection = void 0;
const objectKinds_js_1 = require("../../utils/objectKinds.js");
const compose_js_1 = require("../compose.js");
exports.classIntersection = (0, compose_js_1.composeIntersection)((l, r, state) => {
    return l === r
        ? (0, compose_js_1.equality)()
        : l instanceof r
            ? l
            : r instanceof l
                ? r
                : state.addDisjoint("class", l, r);
});
const checkClass = (expectedClass, state) => {
    if (typeof expectedClass === "string") {
        return ((0, objectKinds_js_1.objectKindOf)(state.data) === expectedClass ||
            !state.problems.add("class", expectedClass));
    }
    return (state.data instanceof expectedClass ||
        !state.problems.add("class", expectedClass));
};
exports.checkClass = checkClass;
