"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.listUnion = exports.collapsibleListUnion = void 0;
const compose_js_1 = require("../compose.js");
const collapsibleListUnion = (l, r) => {
    if (Array.isArray(l)) {
        if (Array.isArray(r)) {
            const result = (0, exports.listUnion)(l, r);
            return result.length === l.length
                ? result.length === r.length
                    ? (0, compose_js_1.equality)()
                    : l
                : result.length === r.length
                    ? r
                    : result;
        }
        return l.includes(r) ? l : [...l, r];
    }
    if (Array.isArray(r)) {
        return r.includes(l) ? r : [...r, l];
    }
    return l === r ? (0, compose_js_1.equality)() : [l, r];
};
exports.collapsibleListUnion = collapsibleListUnion;
const listUnion = (l, r) => {
    const result = [...l];
    for (const expression of r) {
        if (!l.includes(expression)) {
            result.push(expression);
        }
    }
    return result;
};
exports.listUnion = listUnion;
