"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.checkDivisor = exports.divisorIntersection = void 0;
const compose_js_1 = require("../compose.js");
exports.divisorIntersection = (0, compose_js_1.composeIntersection)((l, r) => l === r ? (0, compose_js_1.equality)() : Math.abs((l * r) / greatestCommonDivisor(l, r)));
// https://en.wikipedia.org/wiki/Euclidean_algorithm
const greatestCommonDivisor = (l, r) => {
    let previous;
    let greatestCommonDivisor = l;
    let current = r;
    while (current !== 0) {
        previous = current;
        current = greatestCommonDivisor % current;
        greatestCommonDivisor = previous;
    }
    return greatestCommonDivisor;
};
const checkDivisor = (divisor, state) => state.data % divisor === 0 || !state.problems.add("divisor", divisor);
exports.checkDivisor = checkDivisor;
