"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.regexIntersection = exports.checkRegex = exports.getRegex = void 0;
const compose_js_1 = require("../compose.js");
const collapsibleSet_js_1 = require("./collapsibleSet.js");
const regexCache = {};
const getRegex = (source) => {
    if (!regexCache[source]) {
        regexCache[source] = new RegExp(source);
    }
    return regexCache[source];
};
exports.getRegex = getRegex;
const checkRegex = (source, state) => (0, exports.getRegex)(source).test(state.data) ||
    !state.problems.add("regex", `/${source}/`);
exports.checkRegex = checkRegex;
exports.regexIntersection = (0, compose_js_1.composeIntersection)((collapsibleSet_js_1.collapsibleListUnion));
