"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.writeImplicitNeverMessage = exports.compileDisjointReasonsMessage = void 0;
const compose_js_1 = require("../../nodes/compose.js");
const generics_js_1 = require("../../utils/generics.js");
const compileDisjointReasonsMessage = (disjoints) => {
    const paths = (0, generics_js_1.objectKeysOf)(disjoints);
    if (paths.length === 1) {
        const path = paths[0];
        return `${path === "/" ? "" : `At ${path}: `}Intersection of ${compose_js_1.disjointDescriptionWriters[disjoints[path].kind](disjoints[path])} results in an unsatisfiable type`;
    }
    let message = `
        "Intersection results in unsatisfiable types at the following paths:\n`;
    for (const path in disjoints) {
        message += `  ${path}: ${compose_js_1.disjointDescriptionWriters[disjoints[path].kind](disjoints[path])}\n`;
    }
    return message;
};
exports.compileDisjointReasonsMessage = compileDisjointReasonsMessage;
const writeImplicitNeverMessage = (path, operator, description) => `${path.length ? `At ${path}: ` : ""}${operator} ${description ? `${description} ` : ""}results in an unsatisfiable type`;
exports.writeImplicitNeverMessage = writeImplicitNeverMessage;
