"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.parseNarrowTuple = void 0;
const node_js_1 = require("../../nodes/node.js");
const definition_js_1 = require("../definition.js");
const distributableFunction_js_1 = require("./distributableFunction.js");
const parseNarrowTuple = (def, ctx) => {
    const inputNode = (0, definition_js_1.parseDefinition)(def[0], ctx);
    const resolution = ctx.type.scope.resolveNode(inputNode);
    const hasConfig = (0, node_js_1.isConfigNode)(resolution);
    const typeNode = hasConfig ? resolution.node : resolution;
    const result = (0, node_js_1.rootIntersection)(inputNode, (0, distributableFunction_js_1.distributeFunctionToNode)(def[2], typeNode, ctx, "narrow"), ctx.type);
    return hasConfig
        ? { config: resolution.config, node: result }
        : result;
};
exports.parseNarrowTuple = parseNarrowTuple;
