"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.parseRecord = void 0;
const definition_js_1 = require("./definition.js");
const scanner_js_1 = require("./string/shift/scanner.js");
const parseRecord = (def, ctx) => {
    const props = {};
    for (const definitionKey in def) {
        let keyName = definitionKey;
        let isOptional = false;
        if (definitionKey[definitionKey.length - 1] === "?") {
            if (definitionKey[definitionKey.length - 2] === scanner_js_1.Scanner.escapeToken) {
                keyName = `${definitionKey.slice(0, -2)}?`;
            }
            else {
                keyName = definitionKey.slice(0, -1);
                isOptional = true;
            }
        }
        ctx.path.push(keyName);
        const propNode = (0, definition_js_1.parseDefinition)(def[definitionKey], ctx);
        ctx.path.pop();
        props[keyName] = isOptional ? ["?", propNode] : propNode;
    }
    return {
        object: {
            props
        }
    };
};
exports.parseRecord = parseRecord;
