"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.writeInvalidDivisorMessage = exports.parseDivisor = void 0;
const generics_js_1 = require("../../../../utils/generics.js");
const numericLiterals_js_1 = require("../../../../utils/numericLiterals.js");
const divisor_js_1 = require("../../../ast/divisor.js");
const parseDivisor = (s) => {
    const divisorToken = s.scanner.shiftUntilNextTerminator();
    const divisor = (0, numericLiterals_js_1.tryParseWellFormedInteger)(divisorToken, (0, exports.writeInvalidDivisorMessage)(divisorToken));
    if (divisor === 0) {
        s.error((0, exports.writeInvalidDivisorMessage)(0));
    }
    const rootDomains = (0, generics_js_1.objectKeysOf)(s.resolveRoot());
    if (rootDomains.length === 1 && rootDomains[0] === "number") {
        s.intersect({ number: { divisor } });
    }
    else {
        s.error((0, divisor_js_1.writeIndivisibleMessage)(s.rootToString()));
    }
};
exports.parseDivisor = parseDivisor;
const writeInvalidDivisorMessage = (divisor) => `% operator must be followed by a non-zero integer literal (was ${divisor})`;
exports.writeInvalidDivisorMessage = writeInvalidDivisorMessage;
