"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.incompleteArrayTokenMessage = exports.writeUnexpectedCharacterMessage = exports.parseOperator = void 0;
const errors_js_1 = require("../../../../utils/errors.js");
const generics_js_1 = require("../../../../utils/generics.js");
const scanner_js_1 = require("../scanner.js");
const bounds_js_1 = require("./bounds.js");
const divisor_js_1 = require("./divisor.js");
// @snipStart:parseOperator
const parseOperator = (s) => {
    const lookahead = s.scanner.shift();
    return lookahead === ""
        ? s.finalize()
        : lookahead === "["
            ? s.scanner.shift() === "]"
                ? s.rootToArray()
                : s.error(exports.incompleteArrayTokenMessage)
            : (0, generics_js_1.isKeyOf)(lookahead, scanner_js_1.Scanner.branchTokens)
                ? s.pushRootToBranch(lookahead)
                : lookahead === ")"
                    ? s.finalizeGroup()
                    : (0, generics_js_1.isKeyOf)(lookahead, scanner_js_1.Scanner.comparatorStartChars)
                        ? (0, bounds_js_1.parseBound)(s, lookahead)
                        : lookahead === "%"
                            ? (0, divisor_js_1.parseDivisor)(s)
                            : lookahead === " "
                                ? (0, exports.parseOperator)(s)
                                : (0, errors_js_1.throwInternalError)((0, exports.writeUnexpectedCharacterMessage)(lookahead));
};
exports.parseOperator = parseOperator;
// @snipEnd
const writeUnexpectedCharacterMessage = (char) => `Unexpected character '${char}'`;
exports.writeUnexpectedCharacterMessage = writeUnexpectedCharacterMessage;
exports.incompleteArrayTokenMessage = `Missing expected ']'`;
