"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.fullStringParse = exports.maybeNaiveParse = exports.parseString = void 0;
const node_js_1 = require("../../nodes/node.js");
const dynamic_js_1 = require("./reduce/dynamic.js");
const operand_js_1 = require("./shift/operand/operand.js");
const operator_js_1 = require("./shift/operator/operator.js");
const parseString = (def, ctx) => ctx.type.scope.parseCache.get(def) ??
    ctx.type.scope.parseCache.set(def, (0, exports.maybeNaiveParse)(def, ctx) ?? (0, exports.fullStringParse)(def, ctx));
exports.parseString = parseString;
const maybeNaiveParse = (def, ctx) => {
    if (ctx.type.scope.addParsedReferenceIfResolvable(def, ctx)) {
        return def;
    }
    if (def.endsWith("[]")) {
        const elementDef = def.slice(0, -2);
        if (ctx.type.scope.addParsedReferenceIfResolvable(def, ctx)) {
            return (0, node_js_1.toArrayNode)(elementDef);
        }
    }
};
exports.maybeNaiveParse = maybeNaiveParse;
const fullStringParse = (def, ctx) => {
    const s = new dynamic_js_1.DynamicState(def, ctx);
    (0, operand_js_1.parseOperand)(s);
    return loop(s);
};
exports.fullStringParse = fullStringParse;
const loop = (s) => {
    while (!s.scanner.finalized) {
        next(s);
    }
    return s.ejectFinalizedRoot();
};
const next = (s) => s.hasRoot() ? (0, operator_js_1.parseOperator)(s) : (0, operand_js_1.parseOperand)(s);
