"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.type = exports.spaces = exports.scopes = exports.ark = exports.arkScope = void 0;
const jsObjects_js_1 = require("./jsObjects.js");
const scope_js_1 = require("./scope.js");
const tsKeywords_js_1 = require("./tsKeywords.js");
const validation_js_1 = require("./validation/validation.js");
exports.arkScope = (0, scope_js_1.scope)({}, {
    name: "standard",
    includes: [tsKeywords_js_1.tsKeywords, jsObjects_js_1.jsObjects, validation_js_1.validation],
    standard: false
});
exports.ark = exports.arkScope.compile();
exports.scopes = {
    root: scope_js_1.rootScope,
    tsKeywords: tsKeywords_js_1.tsKeywordsScope,
    jsObjects: jsObjects_js_1.jsObjectsScope,
    validation: validation_js_1.validationScope,
    ark: exports.arkScope
};
exports.spaces = {
    tsKeywords: tsKeywords_js_1.tsKeywords,
    jsObjects: jsObjects_js_1.jsObjects,
    validation: validation_js_1.validation,
    ark: exports.ark
};
exports.type = exports.arkScope.type;
