"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.FreezingCache = exports.Cache = void 0;
const freeze_js_1 = require("../utils/freeze.js");
class Cache {
    cache = {};
    get root() {
        return this.cache;
    }
    has(name) {
        return name in this.cache;
    }
    get(name) {
        return this.cache[name];
    }
    set(name, item) {
        this.cache[name] = item;
        return item;
    }
}
exports.Cache = Cache;
class FreezingCache extends Cache {
    set(name, item) {
        this.cache[name] = (0, freeze_js_1.deepFreeze)(item);
        return item;
    }
}
exports.FreezingCache = FreezingCache;
