"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.DataWrapper = exports.unitsOf = exports.sizeOf = void 0;
const domains_js_1 = require("./domains.js");
const serialize_js_1 = require("./serialize.js");
const sizeOf = (data) => typeof data === "string" || Array.isArray(data)
    ? data.length
    : typeof data === "number"
        ? data
        : 0;
exports.sizeOf = sizeOf;
const unitsOf = (data) => typeof data === "string"
    ? "characters"
    : Array.isArray(data)
        ? "items long"
        : "";
exports.unitsOf = unitsOf;
class DataWrapper {
    value;
    constructor(value) {
        this.value = value;
    }
    toString() {
        return (0, serialize_js_1.stringify)(this.value);
    }
    get domain() {
        return (0, domains_js_1.domainOf)(this.value);
    }
    get size() {
        return (0, exports.sizeOf)(this.value);
    }
    get units() {
        return (0, exports.unitsOf)(this.value);
    }
    get className() {
        return Object(this.value).constructor.name;
    }
}
exports.DataWrapper = DataWrapper;
