"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.deepFreeze = void 0;
const deepFreeze = (value) => (Object.isFrozen(value)
    ? value
    : Array.isArray(value)
        ? Object.freeze(value.map(exports.deepFreeze))
        : // Object.isFrozen will always be true for non-objects, so we can safely cast to Dictionary
            deepFreezeDictionary(value));
exports.deepFreeze = deepFreeze;
const deepFreezeDictionary = (value) => {
    for (const k in value) {
        (0, exports.deepFreeze)(value[k]);
    }
    return value;
};
