"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.listFrom = exports.hasNominalId = exports.getNominalId = exports.nominal = exports.hasKeys = exports.keyCount = exports.hasSingleKey = exports.hasKey = exports.prototypeKeysOf = exports.objectKeysOf = exports.entriesOf = exports.isKeyOf = exports.asConst = void 0;
const domains_js_1 = require("./domains.js");
const asConst = (t) => t;
exports.asConst = asConst;
const isKeyOf = (k, obj) => k in obj;
exports.isKeyOf = isKeyOf;
const entriesOf = (o) => Object.entries(o);
exports.entriesOf = entriesOf;
const objectKeysOf = (o) => Object.keys(o);
exports.objectKeysOf = objectKeysOf;
/** Mimics output of TS's keyof operator at runtime */
const prototypeKeysOf = (value) => {
    const result = [];
    while (value !== Object.prototype &&
        value !== null &&
        value !== undefined) {
        for (const k of Object.getOwnPropertyNames(value)) {
            if (!result.includes(k)) {
                result.push(k);
            }
        }
        for (const symbol of Object.getOwnPropertySymbols(value)) {
            if (!result.includes(symbol)) {
                result.push(symbol);
            }
        }
        value = Object.getPrototypeOf(value);
    }
    return result;
};
exports.prototypeKeysOf = prototypeKeysOf;
const hasKey = (o, k) => {
    const valueAtKey = o?.[k];
    return valueAtKey !== undefined && valueAtKey !== null;
};
exports.hasKey = hasKey;
const hasSingleKey = (o, k) => k in o && Object.keys(o).length === 1;
exports.hasSingleKey = hasSingleKey;
const keyCount = (o) => Object.keys(o).length;
exports.keyCount = keyCount;
const hasKeys = (value) => (0, domains_js_1.hasDomain)(value, "object") ? Object.keys(value).length !== 0 : false;
exports.hasKeys = hasKeys;
const id = Symbol("id");
const nominal = (o, name) => Object.assign(o, { [id]: name });
exports.nominal = nominal;
const getNominalId = (data) => (0, domains_js_1.hasDomain)(data, "object") && id in data ? data[id] : undefined;
exports.getNominalId = getNominalId;
const hasNominalId = (data, name) => (0, exports.getNominalId)(data) === name;
exports.hasNominalId = hasNominalId;
const listFrom = (data) => (Array.isArray(data) ? data : [data]);
exports.listFrom = listFrom;
