"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.getPath = exports.Path = void 0;
class Path extends Array {
    static fromString(s, delimiter = "/") {
        return s === delimiter ? new Path() : new Path(...s.split(delimiter));
    }
    toString(delimiter = "/") {
        return this.length ? this.join(delimiter) : delimiter;
    }
}
exports.Path = Path;
const getPath = (root, path) => {
    let result = root;
    for (const segment of path) {
        if (typeof result !== "object" || result === null) {
            return undefined;
        }
        result = result[segment];
    }
    return result;
};
exports.getPath = getPath;
